# -*- coding: utf-8 -*-


## find homography from given corner (destination) points
## (c) 2011 by hons
## http://hons.at

## requirements: a working opencv installation
## see: http://opencv.willowgarage.com/wiki/



try: 
    import cv
    swig = False
    transform  = cv.CreateMat( 3, 3 , cv.CV_32FC1 );
    sp  = cv.CreateMat( 4,2 , cv.CV_32FC1 )
    dp  = cv.CreateMat( 4, 2, cv.CV_32FC1 )
    print "init homography using cv"
except:
    from opencv.cv import *
    swig = True
    transform  = cvCreateMat( 3, 3 , CV_32FC1 );
    sp  = cvCreateMat( 4,2 , CV_32FC1 )
    dp  = cvCreateMat( 4, 2, CV_32FC1 )
    print "init homography using swig cv"
    

aspects =1.
aspectd =1.

sp[0,0]= -1*aspects 
sp[0,1]=  1

sp[1,0]= 1*aspects 
sp[1,1]= 1

sp[2,0]= 1*aspects 
sp[2,1]= -1

sp[3,0]=-1*aspects 
sp[3,1]= -1


def aspectsrc(asrc):
    
    aspects =asrc
    sp[0,0]= -1*aspects 
    sp[0,1]=  1

    sp[1,0]= 1*aspects 
    sp[1,1]= 1

    sp[2,0]= 1*aspects 
    sp[2,1]= -1

    sp[3,0]=-1*aspects 
    sp[3,1]= -1

    return findHomography()
    
def aspectdst(asdst):
    global aspectd
    
    aspectd  =asdst
    return findHomography()
    
def dstpoints(p1x,p1y,p2x,p2y,p3x,p3y,p4x,p4y):
    global aspectd
    global dp
    #print "aspectd",aspectd
    dp[0,0]= p1x*aspectd 
    dp[0,1]= p1y

    dp[1,0]= p2x*aspectd 
    dp[1,1]= p2y

    dp[2,0]=  p3x*aspectd 
    dp[2,1]=  p3y

    dp[3,0]= p4x*aspectd
    dp[3,1]= p4y

    return findHomography()

    
def findHomography():

    global sp
    global dp
    global transform

    ## try finding the correct cv-version .. 
   
    try:
        if not swig:
            cv.FindHomography(sp, dp, transform, 0 )#, ransacReprojThreshold=3.0, status=None)
        else: 
            status, transform = cvFindHomography(sp, dp, 0 )#, ransacReprojThreshold=3.0, status=None)
    except:
        try:
            cvFindHomography(sp, dp, transform )
        except:
            print "ERROR: could not find homography"
            
    
    #print [float("%f"%transform[x,y]) for x in range(3) for y in range(3)]

    
    return ( transform[0,0],
             transform[0,1],
             transform[0,2],
             transform[1,0],
             transform[1,1],
             transform[1,2],
             transform[2,0],
             transform[2,1],
             transform[2,2] )
             
